c -----------------------------------------------------------------
c G95 and MPICH and LD_LIBRARY_PATH:
c  export LD_LIBRARY_PATH="/usr/local/mpich2-1.0.3-g95/lib"
c  g95 -w -fpic -I/usr/local/mpich2-1.0.3-g95/include
c      -c hello_world.f90
c  g95 -w -o hello_world.exe hello_world.o
c      -lc -L/usr/local/mpich2-1.0.3-g95/lib -lmpich
c
c -----------------------------------------------------------------
c G95 and MPICH without LD_LIBRARY_PATH:
c  g95 -w -fpic -I/usr/local/mpich2-1.0.3-g95/include
c      -c hello_world.f90
c  g95 -w -o hello_world.exe hello_world.o
c   -lc -L/usr/local/mpich2-1.0.3-g95/lib -lmpich 
c   -Wl,-E,-rpath,/usr/local/mpich2-1.0.3-g95/lib
c
c -----------------------------------------------------------------
c G95 and MPICH2 with static libraries:
c  g95 -w -fpic -I/usr/local/mpich2-1.0.3-noshared/include 
c      -c hello_world.f90
c  g95 -w -o hello_world.exe hello_world.o 
c       -lc -L/usr/local/mpich2-1.0.3-noshared/lib -lmpich
c
c -----------------------------------------------------------------
c G95 and MPICH2 with dynamic libraries (but with warnings):
c  g95 -w -fpic -I/usr/local/mpich2-1.0.3/include -c hello_world.f90
c  g95 -w -o hello_world.exe hello_world.o -static 
c      -lc -L/usr/local/mpich2-1.0.3/lib -lmpich
c
c -----------------------------------------------------------------
c INTEL and MPICH2 (no-shared):
c   ifort -c -free -auto 
c         -I/usr/local/mpich2-1.0.3-intel-ns/include hello_world.f90
c   ifort -w -o hello_world.exe hello_world.o 
c         -lc -L/usr/local/mpich2-1.0.3-intel-ns/lib -lmpich
c -----------------------------------------------------------------
c INTEL and MPICH and LD_LIBRARY_PATH:
c  export LD_LIBRARY_PATH="/net/local/mpich2-1.0.3/lib"
c  ifort -fpic -I/net/local/mpich2-1.0.3/include -c hola_f90.f90
c  ifort -o hola_f90.exe hola_f90.o -lc -L/net/local/mpich2-1.0.3/lib -lmpich
c
c -----------------------------------------------------------------
c MPD:
c  mpdboot -n 21 -f ~/mpd.hosts
c  mpdtrace
c  mpdringtest
c  mpiexec -machinefile ~/machi.dat -np 3 hello_world.exe
c  mpdallexit
c  pdsh -a hostname
c
c -------------------------------------------------------------------
      program hola
c     use mpi
c     implicit none
      integer :: myid=0, siza=0, ierr
      write (*,*)
c     call MPI_Init ( ierr )
c     call MPI_Comm_size (MPI_COMM_WORLD, siza, ierr) ! nro de proces.
c     call MPI_Comm_rank (MPI_COMM_WORLD, myid, ierr) ! my rank
      write (*,*)"hola desde ", myid, " de ", siza
c     call MPI_Finalize ( ierr )
      write (*,*)
      end program 
c -------------------------------------------------------------------

