c -----------------------------------------------------------------
c GFORTRAN:   
c  gfortran -c hola_f77.f -fpic -I/usr/local/mpich2/1.0.3/include
c  gfortran -o hola_f77.exe hola_f77.o -lc -L/usr/local/mpich2/1.0.3/lib -lmpich
c
c G77  + MPICH2SHARED (pero con warnings)
c  g77 -c hola_f77.f -fpic -I/usr/local/mpich2-1.0.3/include
c  g77 -o hola_f77.exe hola_f77.o -static -lc -L /usr/local/mpich2-1.0.3/lib -lmpich
c
c compilacion con MPICH2-NOSHARED (sin warnings)
c  g77 -w -fpic -I/usr/local/mpich2-1.0.3-noshared/include -c hola_f77.f
c  g77 -w -o hola_f77.exe hola_f77.o -lc -L /usr/local/mpich2-1.0.3-noshared/lib -lmpich
c
c MPD:
c  mpdboot -n 21 -f ~/mpd.hosts
c  mpdtrace
c  mpdringtest
c  mpiexec -machinefile ~/machi.dat -np 21 hola_f77.exe
c  mpirun -machinefile machi.dat -nolocal -np 16 hola_f77.exe
c  mpdallexit
c -------------------------------------------------------------------
      program hola_mundo
      include 'mpif.h'
      integer :: myid, siza, ierr
      write (*,*)
      call MPI_INIT ( ierr )
      call MPI_Comm_size (MPI_COMM_WORLD, siza, ierr) ! nro de proces.
      call MPI_Comm_rank (MPI_COMM_WORLD, myid, ierr) ! my rank
      write (*,*)' hola desde ', myid, ' de ', siza
      call MPI_Finalize ( ierr )
      write (*,*)
      end program 
c -------------------------------------------------------------------
