!  -----------------------------------------------------------------
! INTEL: 
!  ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a01.f90
!  ifort -o omp_a01.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a01.f90
!
!  -----------------------------------------------------------------
! PGI:
!  pgf90 -V -Minfo -mp -fast -c omp_a01.f90
!  pgf90 -V -Minfo -mp -fast -o omp_a01_f90.exe omp_a01.o
! 
!  -----------------------------------------------------------------
! ADAPTOR:
!  adaptor -openmp -free -o omp_a01_ada.exe omp_a01.f90
!  export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
! 
!  -----------------------------------------------------------------
program a01
  implicit none
  integer, parameter     :: n = 100
  real   , dimension (n) :: a, b
  integer :: i
  !titulos
  write (*,*)
  write (*,*)'A01: executing a simple loop in parallel '
  write (*,*)
  !tarea demo
  !omp$  parallel do
    do  i = 1, n
      a (i) = (i+1) * 1.0 
    end do ! i
  !omp$ parallel do
    do  i = 2, n
      b (i) = ( a (i) +  a (i-1) ) / 2
    end do ! i
  !finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
end program
!  =================================================================
