// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a02.cpp
//  icc -o omp_a02.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a02.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a02.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a02_cpp.exe omp_a02.o
//
// -----------------------------------------------------------------
#include <iostream>
#include <omp.h>
using namespace std ;

// -----------------------------------------------------------------
int main () {
  // titulos
  cout << endl ;
  cout << " A02: specifying conditional compilation " << endl ;
  cout << endl ;
  // tarea demo
  #ifdef _OPENMP
  cout << endl ;
  cout << " compiled by an OMP compliant implementation "<< endl ;
  cout << endl ;
  #endif
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0;
} // end main
// -----------------------------------------------------------------
