// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a03.cpp
//  icc -o omp_a03.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a03.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a03.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a03_cpp.exe omp_a03.o
//
// -----------------------------------------------------------------
#include <iostream>
//#include <omp.h>
using namespace std ;

void tarea0 (int n, int nh) {
  cout << "var. compar. ;  n = " << n  << endl; 
  cout << "nro de hilos ; nh = " << nh << endl; 
}

void tarea1 (int n, int id) {
  cout << "var. compar. ;  n = " << n  << endl; 
  cout << "hilo         ; id = " << id << endl; 
}

int main () {
  int n = 7, nh=1, id=0;
  // titulos
  cout << endl ;
  cout << " A03: using parallel regions " << endl ;
  cout << endl ;
  // tarea demo
  #ifdef _OPENMP
  #pragma omp parallel shared (n) private (h, p, m)
  {
    nh = omp_get_num_threads () ;
    id = omp_get_thread_num () ;
    if  (id == 0) 
      tarea0 (n,nh);
    else
      tarea1 (n,id);
  } // end pragma
  #endif
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
