!  -----------------------------------------------------------------
! INTEL: 
!  ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a04.f90
!  ifort -o omp_a04.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a04.f90
!
!  -----------------------------------------------------------------
! PGI:
!  pgf90 -V -Minfo -mp -fast -c omp_a04.f90
!  pgf90 -V -Minfo -mp -fast -o omp_a04_f90.exe omp_a04.o
! 
!  -----------------------------------------------------------------
! ADAPTOR:
!  adaptor -openmp -free -o omp_a04_ada.exe omp_a04.f90
!  export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
! 
!  -----------------------------------------------------------------
program a04
  implicit none
  integer, parameter     :: n = 100
  real   , dimension (n) :: a, b, c
  integer :: i
  !titulos
  write (*,*)
  write (*,*)'A04: using the nowait clause '
  write (*,*)
  !tarea demo
  !omp$ parallel
    !omp$ do
    do  i = 1, n
      a (i) = (i + 1) * 1.0 
    end do ! i
    !omp$ do
    do  i = 1, n
      b (i) = ( a (i) +  a (i - 1) ) / 2.0
    end do ! i
    !omp$ do
    do  i = 1, n
      c (i) = sqrt ( b (i) )
    end do ! i
  !omp$ end parallel
  !finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
end program
!  =================================================================
