!  -----------------------------------------------------------------
!  INTEL: 
!   ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a08.f90
!   ifort -o omp_a08.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a08.f90
!
!  -----------------------------------------------------------------
!  PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a08.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a08_f90.exe omp_a08.o
! 
!  -----------------------------------------------------------------
!  ADAPTOR:
!   adaptor -openmp -free -o omp_a08_ada.exe omp_a08.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!
!  -----------------------------------------------------------------
program a08
  implicit none
  !titulos
  write (*,*)
  write (*,*)'A08: specifying parallel sections '
  write (*,*)
  !tarea demo
  !omp$ parallel sections
  call  xaxis ()
  call  yaxis ()
  call  zaxis ()
  !omp$ end parallel
  !finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    subroutine xaxis () 
      write (*,*)'xaxis '
    end subroutine
    subroutine yaxis () 
      write (*,*)'yaxis '
    end subroutine
    subroutine zaxis () 
      write (*,*)'zaxis '
    end subroutine
end program
!  =================================================================
