// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a09.cpp
//  icc -o omp_a09.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a09.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a09.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a09_cpp.exe omp_a09.o
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
void waxis () { cout << " waxis " << endl ; }
void xaxis () { cout << " xaxis " << endl ; }
void yaxis () { cout << " yaxis " << endl ; }
void zaxis () { cout << " zaxis " << endl ; }

// -----------------------------------------------------------------
int main () {
  // titulos
  cout << endl ;
  cout << " A09: using single directives " << endl ;
  cout << endl ;
  // tarea demo
  #pragma omp parallel
  {
    waxis ();
   #pragma omp barrier
   #pragma omp single
    xaxis ();
   #pragma omp single
    yaxis ();
   #pragma omp single
    zaxis ();
  }
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
