!  -----------------------------------------------------------------
!   INTEL: 
!    ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a15.f90
!    ifort -o omp_a15.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a15.f90
!
!  -----------------------------------------------------------------
!   PGI:
!    pgf90 -V -Minfo -mp -fast -c omp_a15.f90
!    pgf90 -V -Minfo -mp -fast -o omp_a15_f90.exe omp_a15.o
! 
!  -----------------------------------------------------------------
!   ADAPTOR:
!    adaptor -openmp -free -o omp_a15_ada.exe omp_a15.f90
!    export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!
!  -----------------------------------------------------------------
program a15
  implicit none
  integer :: omp_get_thread_num
  integer :: id=0
  !titulos
  write (*,*)
  write (*,*)'A15: determining the number of threads used'
  write (*,*)
  !tarea demo
  !omp$ parallel private (id)
    !$ id = omp_get_thread_num () ! debe estar dentro de zona paralela
    call work (id)
  !omp$ end parallel
  !finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    subroutine work (i)
      integer, intent (in) :: i
      write (*,*)'i = ', i
    end subroutine
end program
!  =================================================================
