! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -o filtra.exe -openmp -fpic -I/opt/intel/fc/9.0/include filtra.f90
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program filtra
  implicit none
  integer, parameter :: n=10
  integer, parameter :: ip = selected_real_kind (12,100)
  integer :: i
  real (kind=ip), dimension (n) :: a = [ (i, i = 1, n) ]
  real (kind=ip), dimension (n-1) :: b = 0.0_ip
  !$omp parallel do shared(a,b)
    do i = 1, (n-1)
      b (i) = 0.5_ip * ( a (i) + a (i+1) )
    end do
  !$omp end parallel do
  print*, "a", a
  print*, "b", b
end program
