! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -o hola_omp.exe -openmp -fpic -I/opt/intel/fc/9.0/include hola_omp.f90
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program hola
  implicit none
  integer :: id, nh
  integer :: omp_get_thread_num
  integer :: omp_get_num_threads
  !omp$ prallell private (id,nh)
  id = omp_get_thread_num()
  nh = omp_get_num_threads()
  if (id == 0) then
    print*,'nro de hilos:',nh
  else
    print*,'hilo:',id
  end if
  !omp$ end parallel
end program
