! adaptor -hpf -dm -free -v -o bola1.exe bola1.f90
! mpiexec -machinefile ~/machi.dat -np 2 bola1.exe
program bola1
  implicit none
  integer, parameter :: idp = kind (1.0d0)
  integer, parameter :: isp = kind (1.0e0)
  integer, parameter :: iin = kind (1)
  !
  integer (iin), parameter :: n = 10
  integer (iin) :: i, j, k, na, nb
  integer (iin), dimension (n,n) :: a, b
! integer (iin), dimension (:,:), allocatable :: a, b
  !
  !hpf$ distribute (*,cyclic) :: a
  !hpf$ align (*,j) with a (*,j) :: b
  !
  na = size (a,1)
  nb = size (b,1)
  print *
  print *, "na", na
  print *, "nb", nb
  call pepe (a,b)
  print *
  print *, "fine ... "  
  contains
    subroutine pepe (x,y)
      integer (iin) :: j, nx, ny
      integer (iin), dimension (:,:) :: x, y
      !hpf$ distribute * (*,cyclic)  :: x
      !hpf$ align (*,j) with * x (*,j) :: y
      nx = size (x,1)
      ny = size (y,1)
      print *
      print *, "nx", nx
      print *, "ny", ny
    end subroutine
end program
