! adaptor -hpf -dm -free -v -o bola4.exe bola4.f90
! mpiexec -machinefile ~/machi.dat -np 2 bola4.exe
module m_datos
  implicit none
  public
  integer, parameter :: idp = kind (1.0d0)
  integer, parameter :: isp = kind (1.0e0)
  integer, parameter :: iin = kind (1)
  contains
    subroutine pepe (x,y)
      integer (iin) :: j, nx, ny
      real    (idp), dimension (:,:) :: x, y
!     integer (iin), dimension (:,:) :: x, y
      !hpf$ distribute * (*,cyclic)  :: x
      !hpf$ align (*,j) with * x (*,j) :: y
      nx = size (x,1)
      ny = size (y,1)
      print *
      print *, "nx", nx
      print *, "ny", ny
    end subroutine
end module
!
program bola2
  use m_datos
  implicit none
  !
  integer (iin), parameter :: n = 10
  integer (iin) :: i, j, k, na, nb
! integer (iin), dimension (n,n) :: a, b
! integer (iin), dimension (:,:), allocatable :: a, b
  real    (idp), dimension (:,:), allocatable :: a, b
  !
  !hpf$ distribute (*,cyclic) :: a
  !hpf$ align (*,j) with a (*,j) :: b
  !
  allocate (a (n,n))
  allocate (b (n,n))
  na = size (a,1)
  nb = size (b,1)
  print *
  print *, "na", na
  print *, "nb", nb
  call pepe (a,b)
  deallocate (a)
  deallocate (b)
  print *
  print *, "fine ... "  
end program
