! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!  ifort -vms -o foo4.exe foo4.f90
!  g95 -o foo4.exe foo4.f90
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
module m_puntero
  public
  type tdato
    private
    real, pointer :: p
  end type
  contains
    subroutine asignar (this, a)
      type (tdato), intent (out) :: this
      real, target, intent (in)  :: a
      this % p => a
    end subroutine
end module
!
program foo4
 use m_puntero
 type (tdato) :: b
 real   , target  :: a = 0.0
 integer, pointer :: t
 integer, target  :: x=34, y=0
 !
 call asignar (b, a)
 !
 t => x  ! asociacion, t apunta a la variable "x" con valor actual 34
 print *, "valor inicial   ;   x = ", x
 print *, "al hacer t => x da  t = ", t
 y =  t  ! asigna a "y" el valor actual del apuntado por t
 print *, "al hacer y = t  da  y = ", y
 t => y  ! asociacion, t apunta a la variable "y" con valor actual 34
 print *, "al hacer t => y da  t = ", t
 t = 17  ! asigna al target actual de "t" el valor 17
 print *, "al hacer t = 17 da  t = ", t
 print *, "valor actual    ;   y = ", y
 !
end program
! -----------------------------------------------------------------
