! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!  ifort -vms -o foo5.exe foo5.f90
!  g95 -o foo5.exe foo5.f90
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
module m_sumar
  public
  contains
    !declara e inicia variable "s" <-> implica un atributo "save"
    integer function suma1 (n)  result (z)
      integer, intent (in) :: n
      integer :: i, s = 0
      do  i = 1, n
        s = s + i
      end do
      z = s
    end function
    !declara variable "s" con un atributo "save"
    integer function suma2 (n)  result (z)
      integer, intent (in) :: n
      integer :: i
      integer, save :: s = 0
      do  i = 1, n
        s = s + i
      end do
      z = s
    end function
    !unica re-inicializacion correcta de la variable "s"
    integer function suma3 (n)  result (z)
      integer, intent (in) :: n
      integer :: i, s
      s = 0
      do  i = 1, n
        s = s + i
      end do
      z = s
    end function
end module
!
program foo5
 use m_sumar
 print *
 print *, "erronea declaracion e inicializacion de una variable "
 print *
 print *, "suma1 (1:5) = ", suma1 (5)
 print *, "suma1 (1:5) = ", suma1 (5)
 print *
 print *, "suma2 (1:5) = ", suma2 (5)
 print *, "suma2 (1:5) = ", suma2 (5)
 print *
 print *, "suma3 (1:5) = ", suma3 (5)
 print *, "suma3 (1:5) = ", suma3 (5)
 !
end program
! -----------------------------------------------------------------
