! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! para tiempos
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
module tiempos_m
  use  constan_m
  implicit none
  private        ! por omision todo es privado
  public h1, h2
  public timer
  integer (iin) :: h1, h2
  character (11), parameter :: c = "tiempos_m> "
  contains
  !
  !----------------------------------------------------------------
  subroutine timer (h, n, raiz)
    integer (iin), intent (in) :: h
    integer (iin), intent (in) :: n
    character (*), intent (in) :: raiz
    character (len(raiz)+4) :: arch
    real (idp) :: time
    integer :: kr, p
    !
    p = len_trim (raiz)
    arch = raiz (1:p) // ".tim"
    write (*,*)
    write (*,100) " archivo timer: " // arch
    !
    call system_clock (count_rate = kr)  ! cte para pasar a seg
    time = real (h) / real (kr)          ! pasa de ciclos a seg
    p = number_of_processors ()          ! solo en HPF
    !
    write (*,*)
    write (*,*) "nro de procesadores ;      p = ", p
    write (*,*) "tamanio del arreglo ;      n = ", n
    write (*,*) "nro de ciclos       ;      h = ", h
    write (*,*) "cte de ciclos a seg.;     kr = ", kr
    write (*,*) "tiempo en segundos  ;   time = ", time
    write (*,*)
    write (*,*) " n_proce       n_siza     ciclos     segundos"
    !
    ! resumen a disco
    open (1, file = arch         , &
             status = 'unknown'  , &
             position = 'append')
    write (*,110)  p, n, h, time
    write (1,110)  p, n, h, time
    close (1, status = 'keep')
    write (*,*)
    !
    ! formatos
    100 format (a)
    110 format (1x, i8, 1x, i12, 1x, i10, 4x, e20.8)
  end subroutine
end module
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
