! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Variables globales
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
module m_globals
 use   m_ctes
 implicit none
 public  ! todo es asi excepto lo indicado
 !
 ! para medir tiempos
 integer (iin)                 :: h1, h2, h3, h4
 real    (idp), dimension (8)  :: time
 !
 ! para verificar alocamiento de memoria RAM
 integer (iin), dimension (64) :: ier
 !
 contains
 !
 subroutine  zyztem_clock (h1, arch)
   integer (iin), intent (in) :: h1
   character (*), intent (in) :: arch
   real    (idp) :: time       ! p/tiempos
   integer (iin) :: ciclo      ! p/ciclos 
   integer (iin) :: n, h2, h3  ! p/ciclos
   call  system_clock (count = h2)      ! t2 = second ()
   call  system_clock (count_rate = h3) ! ciclos
   ciclo = h2 - h1                     ! ciclo = h2 - h1
   time  = ciclo / h3                  ! pasa de ciclos a seg
   n = number_of_processors ()
   open  (100, file = arch, status = 'unknown' &
             , position = 'append')
   write (100,110)  n, ciclo, time
   close (100, status = 'keep')
   110 format (1x, i4, 1x, i20, 1x, e24.12)
 end subroutine zyztem_clock
end module
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
