c =================================================================
c  proposito: resolucion de un SEAL mediante LINPACK
c -----------------------------------------------------------------
CVD$R NOVECTOR
        subroutine  faspac  ( a, arch )
        implicit  double  precision  (a - h , o - z)
        character    arch * 12
        dimension    a (1), arch (1), ipvt(10000), z(10000)
c -----------------------------------------------------------------
        common  / lista1 / nel, nod, nsr, nse, nst
     #        , / lista3 /  nx,  nu,  ns,  nb
     #        , / lista6 /  na,  nt,  np,  nq, n0z, n0a, n0c
     #        , / consta / tol, eps, ep1, pig, pi4, coef, ep2
c -----------------------------------------------------------------
c   asignamiento local, n = nel ; nro de paneles.
c -----------------------------------------------------------------
        n   = nel  ! orden
        n_a = nq   ! matriz
c -----------------------------------------------------------------
c   titulos.
c -----------------------------------------------------------------
        write (*,*) 
        write (*,*)' # resolucion del SEAL por LINPAK ...     '
        write (*,*)' # numero de incognitas         -->   n = ',n
        write (*,*)
c -----------------------------------------------------------------
c   factoriza
c -----------------------------------------------------------------
        call dgeco ( a(nq+1), n, n, ipvt, rcond, z)
c -----------------------------------------------------------------
c   numero de condicion.
c -----------------------------------------------------------------
        r0 = dabs (rcond)
        if ( r0 .lt. tol ) then
           write(*,*)' # error (faspac): nro de condicion nulo '
           stop
        cond = 1.0 d0 / rcond
        write (*,*)' #  nro de condicion ;  cond = ', cond
        write (3,*)' #  nro de condicion ;  cond = ', cond
c -----------------------------------------------------------------
c
c -----------------------------------------------------------------
        job = 0
        write (*,*) ' Antes de entrar a dgesl'
        call dgesl (a (nq+1), n, n, ipvt, a(nb+1),job)
        write(*,*) ' Despues de dgesl'
c -----------------------------------------------------------------
c   abre archivo, imprime.
c -----------------------------------------------------------------
        write (*,*)
        write (*,*)' # vector solucion '
        open  (8, file = arch (8), status = 'unknown') ! *.pot
        do  160  i = 1, n
        b = a (nb + i)
        write (*,*) i, real (b)
  160   write (8,*)          b
        close (8, status = 'keep' )
c -----------------------------------------------------------------

        return
        end
c =================================================================
