/*
!! a simple Master/slave (dynamically spawnd) example with 
!!  MPI_Comm_spawn, MPI_Comm_get_parent
!!  both Master and slave executables must be build, see slave

*/


#include<string.h>
#include<stdlib.h>
#include<stdio.h>
#include"mpi.h"

void
main(int argc, char **argv)
{

        int             tag = 0;
        int             my_rank;
        int             num_proc;
        char            message_0[] = "hello slave, i'm your master";
	char            message_1[50];
	char            master_data[] = "slaves to work";
        char 		slave[20];
	int             array_of_errcodes[10];
	int             num;
        MPI_Status      status;
        MPI_Comm        inter_comm;
	


	strcpy(slave,"slave.exe") ;
	num = 3;
	
        MPI_Init(&argc, &argv);
        MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
        MPI_Comm_size(MPI_COMM_WORLD, &num_proc);

	printf("MASTER : spawning 3 slaves ... \n");
							/* spawn slave and send it a message */  
	MPI_Comm_spawn(slave, MPI_ARGV_NULL, num, MPI_INFO_NULL,0, MPI_COMM_WORLD, &inter_comm, array_of_errcodes);
	
	printf("MASTER : send a message to master of slaves ...\n");
	MPI_Send(message_0, 50, MPI_CHAR,0 , tag, inter_comm);

	MPI_Recv(message_1, 50, MPI_CHAR, 0, tag, inter_comm, &status);
	printf("MASTER : message received : %s\n", message_1);

	MPI_Send(master_data, 50, MPI_CHAR,0 , tag, inter_comm);

	    
	
	

        MPI_Finalize();
	exit(0);
}
