!! a simple Master/slave (dynamically spawnd) example with 
!!  MPI_Comm_spawn, MPI_Comm_get_parent
!!  both Master and slave executables must be build, see slave
!!  Note : gmake Master-slave to build ! 
program main
implicit none

include 'mpif.h'

integer :: tag, my_rank, num_proc, num
integer :: IERROR, inter_comm
integer :: status(MPI_STATUS_SIZE)

integer :: array_of_errcodes(10)

character (len = 256) :: message_0, message_1, dat
character (len = 12) :: slave

num = 5
tag = 0
slave = "slave.exe"
dat = "slaves to work"
message_0 = "hello slave, i am your master!" 


call MPI_INIT(IERROR)
call MPI_COMM_RANK(MPI_COMM_WORLD, my_rank, IERROR)
call MPI_COMM_SIZE(MPI_COMM_WORLD, num_proc, IERROR)

print *, "MASTER : spawning 5 slaves ..."
call MPI_COMM_SPAWN(slave, MPI_ARGV_NULL, num, MPI_INFO_NULL, 0, MPI_COMM_WORLD, inter_comm, array_of_errcodes, IERROR)

print *, "MASTER : send a message to master of slaves ..."
call MPI_SEND(message_0, len(message_0), MPI_CHARACTER, 0, tag, inter_comm, IERROR)

call MPI_RECV(message_1, 256, MPI_CHARACTER, 0, tag+1, inter_comm, status, IERROR)

print *,"MASTER : message received from slave :" , message_1
print *, "MASTER : sending data to master fo slaves ..."

call MPI_SEND(dat, len(dat), MPI_CHARACTER, 0, tag+2, inter_comm, IERROR)

call MPI_FINALIZE(IERROR)

end program

