! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinseca: "where"
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:   
!  ifort -c proble02.f90
!  ifort -o proble02.exe proble02.o
!  
! GNU:   
!  g95 -w -c proble02.f90 --free-form
!  g95 -w -o proble02.exe proble02.o
!  
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble02.f90
!  pgf90 -V -Minfo -fast -o proble02.exe proble02.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble02.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble02.exe proble02.o
!  mpirun -machinefile machi.dat -np 1 proble02.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble02.f90
!  adaptor -hpf -dm -o proble02.exe proble02.o
!  mpirun -machinefile machi.dat -np 1 proble02.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program p02
  implicit none
  real   , dimension (6) :: a = [ 1.0, 2.0, 3.0, 4.0, 5.0, 6.0 ]
  integer, dimension (6) :: b = [ 4  , 3  , 2  , 1  , 0  , 0   ]
  real   , dimension (6) :: c
  integer :: i, j, n
  !
  write (*,*)
  write (*,*) "Arreglos, intrinseca: where "
  !
  c = 0.0
  where (b .ne. 0)  c = a / b
  !       
  write (*,*)
  write (*,*)" a      b    c "
  n = size (a, dim = 1)
  do  i = 1, n
  write (*,100) a (i), b (i), c (i) 
  end do
  !
  write (*,*)
  100 format (1x, f4.1, 1x, i4, 3x, f4.1)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
