// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a01.cpp
//  icc -o omp_a01.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a01.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a01.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a01_cpp.exe omp_a01.o
//
// -----------------------------------------------------------------
#include <iostream>
#include <omp.h>
using namespace std ;

// -----------------------------------------------------------------
int main () {
  const int n = 10 ;
  float a [n], b [n] ;
  // titulos
  cout << endl ;
  cout << " A01: executing a simple loop in parallel " << endl ;
  cout << endl ;
  // tarea demo
  #pragma omp parallel for
  for (int i = 0 ; i < n ; i++) a [i] = (i + 1) * 1.0 ;
  #pragma omp parallel for
  for (int i = 1 ; i < n ; i++) b [i] = ( a [i] + a [i-1] ) / 2 ;
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
