// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a07.cpp
//  icc -o omp_a07.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a07.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a08.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a08_cpp.exe omp_a08.o
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
void xaxis () { cout << " xaxis " << endl ; }
void yaxis () { cout << " yaxis " << endl ; }
void zaxis () { cout << " zaxis " << endl ; }

// -----------------------------------------------------------------
int main () {
  // titulos
  cout << endl ;
  cout << " A08: specifying parallel sections " << endl ;
  cout << endl ;
  // tarea demo
  #pragma omp parallel sections
  {
  #pragma omp section
  xaxis ();
  #pragma omp section
  yaxis ();
  #pragma omp section
  zaxis ();
  }
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
