! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -o dotprod.exe -openmp -fpic -I/opt/intel/fc/9.0/include dotprod.f90
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program dotprod
  implicit none
  integer, parameter :: n = 10
  integer, parameter :: ip = kind (1.0d0)
  integer :: i
  real (kind=ip) :: s = 0.0_ip
  real (kind=ip), dimension (n) :: a = 1.0_ip, b = 2.0_ip
  b (3:7) = 0.0_ip
  !$omp parallel do shared (a,b) reduction (+:s)
  do i = 1, n
    s = s + a (i) * b (i)
  end do
  !$omp end parallel do
  print*, "a", a
  print*, "b", b
  print*, "s", s
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
