      program SUBGRIDS

      use HPF_LIBRARY   !  import HPF_SUBGRID_INFO 

! declare the data array 

      integer, parameter :: NX = 100, NY = 100

      real, dimension (NX,NY) :: X

!hpf$ distribute (block,block) :: X

      integer :: I, IERR

! local subgrid parameters are declared per processor
! for a rank-two array

      integer, dimension(number_of_processors(),2) :: LB, UB

!hpf$ distribute (block,*) :: LB, UB

      ! initialize values ( assume stride = 1 )

      print *, 'SUBGRID info of X(100,100), distributed (block,block)'

      call HPF_SUBGRID_INFO (X, IERR, lb=LB, ub=UB )

      do I = 1, number_of_processors ()
         print 10, I, LB(I,1), UB(I,1), LB(I,2), UB(I,2)
      end do

 10   FORMAT('On proc ',I3,':',I3,'-',I3,' x',I3,'-',I3)
      end

