! With Transcriptive Mapping
module m_matriz1
  implicit none
  public
  contains
    subroutine bar (r)
      integer, dimension (:,:) :: r               
      !hpf$ inherit r            
      integer :: i, j, n
      n = size (r,1)    
      do  i = 1, n 
        do  j = 1, n 
          r (i,j) = (i - 1) * n + j
        end do
      end do
    end subroutine
end module
!
program foo1
  use m_matriz1
  implicit none
  integer, parameter :: n = 4
  integer, dimension (n,n) :: t           
  integer, dimension (n,n) :: u  
  integer :: i, j
  !hpf$ distribute t (block,block)
  !hpf$ align u (i,j) with t (i,j)
  call bar (u)
  print *
  print *, "with Transcriptive Mapping ..."
  print *, "u "
  do  i = 1, n 
    print 10, u (i,:)
  end do
  print *
  print *, "fine ..."
  10 format (40(1x,i4))
end program             
