  function  [ f ] = g_gauss2 (A1, B1, A2, B2, n1, n2, f)
% function  [ f ] = g_gauss2 (A1, B1, A2, B2, n1, n2, f)

global X

disp (' ')
disp ('ITERA')

% tamanios y constantes
z = abs (n2 - n1) + 1
m = size (B1,2) ;

% recursion
if  ( z == 1 ),
  disp ('PASO BASE ...')
  n1
  n2
  for j = 1 : m,
    X (n1,j) = B1 (1,j) / A1 (1,1) ;
  end % j
  f = 1
else
  disp ('PASO INDUCTIVO ...')

  % indices
  i1 = n1  
  i2 = floor (z / 2) + (n1 - 1) 
  i3 = i2 + 1
  i4 = n2
  h1 = 1 ;
  h2 = floor (z / 2) ;
  h3 = h2 + 1 ;
  h4 = z ;

  % copias
  disp ('triangulariza hacia adelante ...')
  for   k = 1 : h2,
    %
    [ vmax  imax ] = max ( abs ( A1 (k:z,k) ) ) ;
    q = imax + (k - 1) ;
    for  j = 1 : z,
      t = A1 (k,j) ;
      A1 (k,j) = A1 (q,j) ;
      A1 (q,j) = t ;
    end % j
    for  j = 1 : m,
      t = B1 (k,j) ;
      B1 (k,j) = B1 (q,j) ;
      B1 (q,j) = t ;
    end % j
    %
    for  i = (k + 1) : z,
      A1 (i,k) = A1 (i,k) / A1 (k,k) ;  % subcolumna del pivote
    end % i
    %
    for  i = (k + 1) : z,
      for  j = (k + 1) : z,
        A1 (i,j) = A1 (i,j) - A1 (i,k) * A1 (k,j) ; % reduce sub-bloque
      end % j
      for q = 1 : m,
      B1 (i,q) = B1 (i,q) - A1 (i,k) * B1 (k,q) ;
      end % q
      A1 (i,k) = 0;
    end ; % i
  end % k
% A1
% pause

  disp ('triangulariza hacia atras ...')
  for  k = z : -1 : h3,
    %
    [ vmax  imax ] = max ( abs ( A2 (1:k,k) ) ) ;
    q = imax ;
    for  j = 1 : z,
      t = A2 (k,j) ;
      A2 (k,j) = A2 (q,j) ;
      A2 (q,j) = t ;
    end % j
    for  j = 1 : m,
      t = B2 (k,j) ;
      B2 (k,j) = B2 (q,j) ;
      B2 (q,j) = t ;
    end % j
    %
    for  i = (k - 1) : -1 : 1,
      A2 (i,k) = A2 (i,k) / A2 (k,k) ;                % subcolumna del pivote
    end % i
    for  i = (k - 1) : -1 : 1,
       for  j = (k - 1) : -1 : 1,
         A2 (i,j) = A2 (i,j) - A2 (i,k) * A2 (k,j) ;  % reduce sub-bloque
       end % j
       for q = 1 : m,
         B2 (i,q) = B2 (i,q) - A2 (i,k) * B2 (k,q) ;
       end % q
       A2 (i,k) = 0 ;
    end ; % i
  end % k
% A2
% pause

  disp ('va a RECURSION UP ')
  [ f1 ] = g_gauss2 ( A2 (h1:h2,h1:h2), B2 (h1:h2,1:m), 
                      A2 (h1:h2,h1:h2), B2 (h1:h2,1:m), i1, i2, f)

  disp ('va a RECURSION DOWN ')
  [ f2 ] = g_gauss2 ( A1 (h3:h4,h3:h4), B1 (h3:h4,1:m), 
                      A1 (h3:h4,h3:h4), B1 (h3:h4,1:m), i3, i4, f)
  f = f1 + f2 + 1

end % if

endfunction
