c23456789         
        program over4
        implicit none
        integer, parameter :: idp = kind (1.0 d0)
        integer, parameter :: iin = kind (1)
        real    (idp), dimension (:)  , allocatable :: x
        real    (idp), dimension (:,:), allocatable :: xx, yy
        real    (idp), dimension (:,:), pointer     :: zz
        real    (idp) :: s
        integer (iin) :: i, j, m, n
c ----------------------------------------------------------------
   10   write (*,*)' n : ? '
        read (*,*,err=10) n
        allocate ( x (n) )
        x = (/(i, i = 1, n)/)
        write (*,*)' x  ', x
        s = sum (x)
        write (*,*)' s  ', s
c ----------------------------------------------------------------
   20   write (*,*)' n : ? '
        read (*,*,err=20) n
   30   write (*,*)' m : ? '
        read (*,*,err=30) m
        allocate ( xx (n,m) , yy (n,m), zz (n,m) )
        xx = 0
        yy = 0
        zz = 0
        do  i = 1, n
        xx (i,i) = 1
        end do
        yy (1,2) = 1
        yy (2,3) = 1
        yy (3,1) = 1
        zz => pvec2 (xx,yy)
        do i = 1, n
        write (*,*)' zz ', ( zz (i,j), j = 1, m )
        end do
c ----------------------------------------------------------------
        contains
c ----------------------------------------------------------------
        function  pvec2 (x,y)
        implicit none
        integer, parameter :: idp = kind (1.0d0)
        integer, parameter :: iin = kind (1)
        real    (idp), dimension (:,:), intent (in) :: x, y
        real    (idp), dimension (:,:), pointer :: pvec2
        integer (iin) :: i, n, m
        n = size (x, dim = 1)
        m = size (x, dim = 2)
        allocate ( pvec2 (n,m) )
        pvec2 (:,1) = x (:,2) * y (:,3) - y (:,2) * x (:,3)
        pvec2 (:,2) = x (:,3) * y (:,1) - y (:,3) * x (:,1)
        pvec2 (:,3) = x (:,1) * y (:,2) - y (:,1) * x (:,2)
        end function
c ----------------------------------------------------------------
        function sum (x)
        implicit none
        integer, parameter :: idp = kind (1.0d0)
        integer, parameter :: iin = kind (1)
        real    (idp), dimension (:), intent (in) :: x
        real    (idp) :: sum
        integer (iin) :: i, n
        real    (idp), parameter :: cero = 0.0
        n = size (x, dim = 1)
        sum = cero
        do i = 1, n
        sum = sum + x (i)
        end do
        end function
c ----------------------------------------------------------------
        end program
c ----------------------------------------------------------------

