!! a simple/Master slave (dynamically spawnd) examplewith 
!!  MPI_Comm_spawn, MPI_Comm_get_parent
!!  both Master and slave executables must be build, see Master  
!!  Note: gmake Master-client to build !
program main
implicit none

include 'mpif.h'

integer :: tag, my_rank, num_proc, num
integer :: IERROR, inter_comm
integer :: status(MPI_STATUS_SIZE)

character (len = 256) :: message_0, message_1, slave_data

tag = 0
message_1 = "hallo master"


call MPI_INIT(IERROR)
call MPI_COMM_RANK(MPI_COMM_WORLD, my_rank, IERROR)
call MPI_COMM_SIZE(MPI_COMM_WORLD, num_proc, IERROR)
call MPI_COMM_GET_PARENT(inter_comm, IERROR)
 
                                                       ! the master gets a message from the
                                                       ! parent (Mater) and broadcasts it to the
                                                       ! other processes (slave) 

if ( my_rank == 0) then
    call MPI_RECV(message_0, 256, MPI_CHARACTER, 0, tag, inter_comm, status, IERROR)
    print *,"SLAVE (master) : message received: ", message_1

    call MPI_SEND(message_1, len(message_1), MPI_CHARACTER, 0, tag+1, inter_comm,IERROR)
 
    call MPI_RECV(slave_data, 256, MPI_CHARACTER, 0, tag+2, inter_comm, status, IERROR)

    print *, "SLAVE (master) : slave data received: ", slave_data

end if

call MPI_BCAST(slave_data, len(slave_data), MPI_CHARACTER, 0, MPI_COMM_WORLD, IERROR)
print *, "Slave", my_rank, "slave data revceived: " , slave_data

call MPI_FINALIZE(IERROR)

end program 










